import csv

ifile = csv.DictReader(open('hoursCostData.csv'))

def convertColumns(rec, clist, typelist):
    for c,t in zip(clist, typelist):
        rec[c] = t(rec[c])
    return rec

# Read in the people's data and compute the minimum start time
# and the maximum end time
recs = []
mintime = float('inf')
maxtime = -float('inf')
for r in ifile:
    r = convertColumns( r, ('Cost', 'HoursStart', 'HoursEnd'), (float,float,float))
    mintime = min(mintime, r['HoursStart'])
    maxtime = max(maxtime, r['HoursEnd']) 
    recs.append(r)

# Now output the nodes set
nodesset = range(int(mintime), int(maxtime)+1)
ofile = open('gams_nodesSet.csv','w')
for i in nodesset:
    print >> ofile, 'Hour%d'%int(i)
ofile.close()

# Now output the arc set and the arcs data
arcs = {}
for r in recs:
    for j in range(int(r['HoursStart']), int(r['HoursEnd']) ):
        arc = (j, int(r['HoursEnd']))
        if ( arc not in arcs ) or ( arcs[arc]['Cost'] > r['Cost']):
            arcs[arc] = {}
            arcs[arc]['Cost'] = r['Cost']
            arcs[arc]['Person'] = r['Name']

ofile = open('gams_arcsSet.csv','w')
for i,j in arcs:
    print >> ofile, 'Hour%d,Hour%d'%(int(i),int(j))
ofile.close()

ofile = open('gams_acronyms.csv','w')
for r in recs:
    print >> ofile, r['Name']
ofile.close()

ofile = open('gams_arcsData.csv','w')
print >> ofile, 'StartNode,EndNode,Cost,Person'
for i,j in arcs:
    print >> ofile, 'Hour%d,Hour%d,%f,%s'%(int(i),int(j),arcs[(i,j)]['Cost'],arcs[(i,j)]['Person'])
ofile.close()




